# pio_not_gate.py - 12.09.2021
#
# Spiegelt einen Eingangspin invertiert auf einen Ausgangspin

from machine import Pin
from rp2 import PIO, StateMachine, asm_pio

class Not_Gate(object):
    def __init__(self, statemachine, input_pin, output_pin, freq=100_000_000):
        self.sm = StateMachine(statemachine, self.invert,
                               in_base=Pin(input_pin, Pin.IN, Pin.PULL_DOWN),
                               sideset_base=Pin(output_pin),
                               freq=freq)
        self.sm.restart()
        self.sm.active(1)
    
    @staticmethod
    @asm_pio(sideset_init=PIO.OUT_HIGH)
    def invert():    
        wrap_target()
        wait(0, pin, 0)    .side(0)
        wait(1, pin, 0)    .side(1)
        wrap()


if __name__ == "__main__":
    
    # Taster an Pin 17, zieht activ auf high,
    # LED an Pin 0
    Not_Gate(statemachine=7, input_pin=17, output_pin=0)
    
    print("Running on statemachine ...")
 